#include <stdio.h>
#include <stdlib.h>

#include "type.h"
#include "common.h"


struct display_descr basic_clock, basic_clock2;
struct display_descr basic_clock_bis, basic_clock2_bis;



/*======================================================================*/
void putlabel(Widget w, char *c) 
/************* Change the widget label */
{
    XmString str;
    Arg al[1];
    int ac = 0;

    str = XmStringCreateLtoR(c, XmSTRING_DEFAULT_CHARSET);
    (void) XtSetArg(al[ac], XmNlabelString, str); ac++;
    (void) XtSetValues(w, al, ac);
    (void) XmStringFree(str);
}
/*======================================================================*/

/*======================================================================*/
int realtoint(float v) 
/*********** Type conversion */
{
    return((int) v);
}


int REALTOINT(float v) 
/*********** Type conversion */
{
    return((int) v);
}
/*======================================================================*/

/*======================================================================*/
/*-------------------
  Program termination
  -------------------*/
void wstop(int *b)
{
    exit(0);
}
/*======================================================================*/



/****======================================================================****/
/****======================================================================****/
/****                                                                      ****/
/****                                                                      ****/
/****                        MONITORING PANEL                              ****/ 
/****                                                                      ****/
/****                                                                      ****/
/****======================================================================****/
/****======================================================================****/


void make_display_scale(struct rhythm_descr *scale_pt,int X,int Y)
/*******************************  Initialization procedure */

{ 
   Widget mys_widget;
   XGCValues values;

    mys_widget=(*scale_pt).discount;
    values.font =  XLoadFont(XtDisplay(mys_widget),"6x10");
    XtVaGetValues(mys_widget,XmNforeground,&values.foreground,
		  XmNbackground,&values.background,NULL);
    (*scale_pt).dgc = XtGetGC(mys_widget,GCForeground|GCBackground|GCFont,&values);
    (*scale_pt).dgchi = 10;
    (*scale_pt).dgcwi = 6;
    (*scale_pt).x = X;
    (*scale_pt).y = Y;
    (*scale_pt).vcode = NUL_CODE;
}
/*======================================================================*/




/*======================================================================*/     
bool rupdown(struct rhythm_descr *widgst_pt)
/********************** Called by the SIGNAL program to get indicator*/
{
  long int off4;

    off4 = (*widgst_pt).vupdown;
    return(off4);
}
/*======================================================================*/




/*======================================================================*/
int rchange(struct rhythm_descr *widgst_pt)
/********************* Called by the SIGNAL program to get event*/
{
  long int off4;

    off4 =(*widgst_pt).vcode;
    (*widgst_pt).vcode = NUL_CODE;
    return(off4);
}
/*======================================================================*/




/*======================================================================*/
void wnbwrite(struct rhythm_descr *widgst_pt,char str_v[10])
/************************ */
{
  Display *ecran;
  Window fenetre;
  int height;
  int x1,y1;
  x1=(*widgst_pt).x;
  y1=(*widgst_pt).y;
  ecran=XtDisplay((*widgst_pt).discount);
  fenetre=XtWindow((*widgst_pt).discount);
  height=(*widgst_pt).dgchi;
  XClearArea(ecran,fenetre,x1,y1-height+1,10*(*widgst_pt).dgcwi,height,FALSE); 
  XDrawString(ecran,fenetre,(*widgst_pt).dgc,x1,y1,str_v,10);
}
/*======================================================================*/




/*======================================================================*/
/*------------------ write an integer number*/
void wiwrite(struct rhythm_descr *widgst_pt,int v)
{
  char str_v[11];
  sprintf(str_v,"%10d",v);
  wnbwrite(widgst_pt,str_v);
}
/*======================================================================*/




/*======================================================================*/
/*------------------ write a float number */
void wrwrite(struct rhythm_descr *widgst_pt,float v)
{
  char str_v[11];
  sprintf(str_v,"%.9f",v);
  wnbwrite(widgst_pt,str_v);
}
/*======================================================================*/



/****======================================================================****/
/****======================================================================****/
/****                                                                      ****/
/****                                                                      ****/
/****                  DRAWING AREA : INITIALISATIONS  DES WIDGET          ****/ 
/****                                                                      ****/
/****                                                                      ****/
/****======================================================================****/
/****======================================================================****/



/*======================================================================*/
 struct display_descr *get_display(int numero_ecran)
/**********************************Initialization called by the SIGNAL program 
                                   to get the window descriptor */

{
  switch (numero_ecran) {
  case 1: 
    make_display_descr(&basic_clock,CANVAS_HEIGHT-30);
    return(&basic_clock); 
   break;

  case 2: 
    make_display_descr(&basic_clock2,CANVAS_HEIGHT-30);
    return(&basic_clock2);
  break;

  case 3: 
    make_display_descr(&basic_clock_bis,CANVAS_HEIGHT_BIS-30);
    return(&basic_clock_bis);
  break;

  case 4: 
    make_display_descr(&basic_clock2_bis,CANVAS_HEIGHT_BIS-30);
    return(&basic_clock2_bis);
    break;

  default:  
    printf("Numero ecran = %d > 4 \n",numero_ecran);
    break;
  } 
}
/*======================================================================*/


/*======================================================================*/
void make_display_descr(struct display_descr *display_pt,int DY)
/********************************  Initialization procedure */
{
   Widget widget,widget2;
   XGCValues values;

    widget=(*display_pt).ecran_x;
    values.font = XLoadFont(XtDisplay(widget),"6x10");
    XtVaGetValues(widget,XmNforeground,&values.foreground,
  		XmNbackground,&values.background,NULL);
    (*display_pt).dgc=XtGetGC(widget,GCForeground|GCBackground|GCFont,&values);
    (*display_pt).y0=DY;
}
/*======================================================================*/



/****======================================================================****/
/****======================================================================****/
/****                                                                      ****/
/****                                                                      ****/
/****     FONCTIONS POUR LA FENETRE D'AFFICHGE de PUISSANCE ET             ****/ 
/****                LE TRACE DE L"AXE DES X                               ****/
/****                                                                      ****/
/****                                                                      ****/
/****======================================================================****/
/****======================================================================****/




/*======================================================================*/
void wiwrite_x(struct display_descr *widgst_pt,int v,int x,int y)
/**************************************/  
{
  char str_v[3];
  sprintf(str_v,"%2d",v);
  XDrawString(XtDisplay((*widgst_pt).ecran_x),
	      XtWindow((*widgst_pt).ecran_x),
	      (*widgst_pt).dgc,x-5,(*widgst_pt).y0+y,str_v,2);

}
/*======================================================================*/




/*======================================================================*/
void wvline_x(struct display_descr *widgst_pt,long int x1,long int y1,long int y2)
/************************ Draw a vertical line */
{
    XDrawLine(XtDisplay((*widgst_pt).ecran_x),XtWindow((*widgst_pt).ecran_x),(*widgst_pt).dgc,
    x1,y1+(*widgst_pt).y0,x1,y2+(*widgst_pt).y0);
}
/*======================================================================*/




/*======================================================================*/
void wline_x(struct display_descr *widgst_pt, long int x1, long int y1, long int x2, long int y2)
/************************ Draw a vertical line */
{
    XDrawLine(XtDisplay((*widgst_pt).ecran_x),XtWindow((*widgst_pt).ecran_x),(*widgst_pt).dgc,
    x1,-y1+(*widgst_pt).y0,x2,-y2+(*widgst_pt).y0);
}
/*======================================================================*/




/*======================================================================*/
void whline_x(struct display_descr *widgst_pt,long int x1,long int y1,long int x2)
/************************ Draw an horizontal line */
{
    XDrawLine(XtDisplay((*widgst_pt).ecran_x),XtWindow((*widgst_pt).ecran_x),(*widgst_pt).dgc,
    x1,-y1+(*widgst_pt).y0,x2,-y1+(*widgst_pt).y0);
}
/*======================================================================*/




/*======================================================================*/
void wefface_x(struct display_descr *widgst_pt,long int x1,long int dx,long int dy)
/**************************** Clear a rectangular array */
{
   XClearArea(XtDisplay((*widgst_pt).ecran_x),XtWindow((*widgst_pt).ecran_x),
   x1,(*widgst_pt).y0-dy,dx,2*dy,FALSE);
}
/*======================================================================*/




/****======================================================================****/
/****======================================================================****/
/****                                                                      ****/
/****                                                                      ****/
/****     FONCTIONS POUR LA FENETRE D'AFFICHAGE de L"EHELLE des Y          ****/ 
/****                                                                      ****/
/****                                                                      ****/
/****======================================================================****/
/****======================================================================****/



/*======================================================================*/
void trace_echelle_y(struct display_descr *widgst_pt, float p_max, int y_max)
/********************* trace de l'axe des Y par le programme SIGNAL */
/* p_max est la puissance maximale apparaissant a l'ordonnee y_max */
/* valeur normale de y_max:140 pixel */
{
  int x1,x2,y1,y2;
  int i,hauteur;

  hauteur = (*widgst_pt).y0;
  whline_y(widgst_pt,30,hauteur,40); /* debut de l'axe des x */ 
  wvline_y(widgst_pt,39,0,hauteur); /* trace de l'axe vertical */
  for (i=0; i<=10; i++)
    {
      whline_y(widgst_pt,35,hauteur-14*i,40);
      wiwrite_y(widgst_pt,((int) (14*i*p_max/y_max)),5,hauteur-14*i+5);
    }
}
/*======================================================================*/




/*======================================================================*/
void wiwrite_y( struct display_descr *widgst_pt,int v,int x,int y)
/**************************************/ 


{
  char str_v[6];
  sprintf(str_v,"%5d",v);
  XDrawString(XtDisplay((*widgst_pt).ecran_y),
	      XtWindow((*widgst_pt).ecran_y),
	      (*widgst_pt).dgc,x,y,str_v,5);

}
/*======================================================================*/




/*======================================================================*/
void wvline_y(struct display_descr *widgst_pt,long int x1,long int y1,long int y2)
/************************ Draw a vertical line */
{
    XDrawLine(XtDisplay((*widgst_pt).ecran_y),XtWindow((*widgst_pt).ecran_y),(*widgst_pt).dgc,
    x1,y1,x1,y2);
}
/*======================================================================*/




/*======================================================================*/
void wline_y(struct display_descr *widgst_pt,long int x1,long int y1,long int x2,long int y2)
/************************ Draw a vertical line */
{
    XDrawLine(XtDisplay((*widgst_pt).ecran_y),XtWindow((*widgst_pt).ecran_y),(*widgst_pt).dgc,
    x1,y1,x2,y2);
}
/*======================================================================*/




/*======================================================================*/
void whline_y(struct display_descr *widgst_pt,long int x1,long int y1,long int x2)
/************************ Draw an horizontal line */
{
    XDrawLine(XtDisplay((*widgst_pt).ecran_y),XtWindow((*widgst_pt).ecran_y),(*widgst_pt).dgc,
    x1,y1,x2,y1);
}
/*======================================================================*/



