static Widget mkPaceButton(char *nom, Widget pere, int width, int bordWidth)
{
  return(XtVaCreateManagedWidget(nom, xmPushButtonWidgetClass, pere, 
				 XmNwidth, width,
				 XmNborderWidth, bordWidth, 
				 XmNlabelString, XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET), 
				 NULL));
}

static void mk_pace_control(Widget w)
{
  Widget widg1, t_widg, widg;

  //DOWN/QUIT button
  widg1 = mkPaceButton("QUIT", w, BUTTON_WIDTH, 2);
  XtVaSetValues(widg1, XmNleftAttachment, XmATTACH_FORM, XmNheight, BUTTON_HEIGHT, NULL);
  stop_creat(widg1);
  putlabel(widg1,"QUIT");
  XtAddCallback(widg1, XmNactivateCallback, (XtCallbackProc)inter_stop, NULL);

  // AUTO/MANU button
  widg = mkPaceButton("AUTO", w, BUTTON_WIDTH, 2);
  XtVaSetValues(widg, XmNheight, BUTTON_HEIGHT, XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg1, NULL);
  XtAddCallback(widg, XmNactivateCallback, (XtCallbackProc)inter_auto, NULL);
  putlabel(widg,"AUTO");
  auto_creat(widg);

  // UP/TICK button
  t_widg = mkPaceButton("TICK", w,BUTTON_WIDTH, 2);
  XtVaSetValues(t_widg,  XmNheight, BUTTON_HEIGHT, XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg, NULL);
  XtAddCallback(t_widg, XmNactivateCallback, (XtCallbackProc)inter_tick, NULL);
  putlabel(t_widg,"TICK");
}

static void mk_pace_rhythm(Widget w)
{
  Widget     t_widg, widg1, widg2, widg3, widg4, canvas_widg;

  canvas_widg = XtVaCreateManagedWidget("meter_pace", xmDrawingAreaWidgetClass, w, 
					XmNborderWidth, 0, 
					XmNwidth, PANEL_WIDTH /2 ,
					XmNheight, BUTTON_HEIGHT_PACE,
					XmNleftAttachment, XmATTACH_FORM, XmNtopAttachment, XmATTACH_FORM,
					NULL);
  meter_pace_creat(canvas_widg);

  widg1 = mkPaceButton("+", w, BUTTON_WIDTH_PACE, 2);
  XtVaSetValues(widg1,  XmNheight, BUTTON_HEIGHT_PACE, XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, canvas_widg, NULL);
  XtAddCallback(widg1, XmNactivateCallback, (XtCallbackProc)inter_pace_up_p, NULL);

  widg2 = mkPaceButton("-", w, BUTTON_WIDTH_PACE, 2);
  XtVaSetValues(widg2,  XmNheight, BUTTON_HEIGHT_PACE, XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg1, NULL);
  XtAddCallback(widg2, XmNactivateCallback, (XtCallbackProc)inter_pace_down_p, NULL);

  widg3 = mkPaceButton("/", w, BUTTON_WIDTH_PACE, 2);
  XtVaSetValues(widg3,  XmNheight, BUTTON_HEIGHT_PACE, XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg2 , NULL);
  XtAddCallback(widg3, XmNactivateCallback, (XtCallbackProc)inter_pace_down_m, NULL);

  widg4 = mkPaceButton("*", w,BUTTON_WIDTH_PACE, 2);
  XtVaSetValues(widg4,  XmNheight, BUTTON_HEIGHT_PACE, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg3 , NULL);
  XtAddCallback(widg4, XmNactivateCallback, (XtCallbackProc)inter_pace_up_m, NULL);
}


static void make_pace_maker(Widget w)
{
  Widget  control_widg, rhythm_widg, hour_screen, label;
  
  label = make_label("PACEMAKER", w, BUTTON_HEIGHT, PANEL_WIDTH, 0);
  control_widg = XtVaCreateManagedWidget("pace_control", xmFormWidgetClass, w,
					 XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, label,
					 NULL);

  mk_pace_control(control_widg);
  
  rhythm_widg = XtVaCreateManagedWidget("pace_rhythm", xmFormWidgetClass, w, 
					XmNborderWidth, 0,
					XmNwidth, PANEL_WIDTH, 
					XmNleftAttachment, XmATTACH_FORM,
					XmNrightAttachment, XmATTACH_FORM,
					XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, control_widg,
					NULL);
  mk_pace_rhythm(rhythm_widg);

  hour_screen = XtVaCreateManagedWidget("hour_screen", xmDrawingAreaWidgetClass, w, 
					XmNborderWidth, 0,
					XmNwidth, PANEL_WIDTH, XmNheight, BUTTON_HEIGHT, 
					XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, rhythm_widg,
					NULL);
  
  meter_heure_creat(hour_screen);
}
